#include "..\ADT-string\str.h"
#include "..\ADT-sheet\sheet.h"
#include "functions.h"

#ifndef expression_h
#define expression_h
///PROTOTYPES

boolean is_alphabet(char ch);
/*fungsi ini merupakan fungsi bantuan yang dipakai dalam fungsi
is_cell. menghasilkan TRUE apabila ch termasuk A-Z*/

boolean is_cell(str cell);
/*menghasilkan TRUE apabila cell adalah suatu alamat sel*/

boolean is_bool_exp(str exp,sheet sh);
/*menghasilkan true apabila ekspresi menghasilkan boolean (and,or,not,opr bool,sel boole,langsung bool)*/

boolean is_char_exp(str exp,sheet sh);
/*menghasilkan true apabila ekspresi menghasilkan karakter (concat,sel kar,langsung kar)*/

boolean is_if_exp(str exp,sheet sh);
/*menghasilkan true apabila ekspresi if/sel if*/

boolean is_bool_func(str exp,sheet sh);
/*Menghasilkan true apabila ekspresi exp adalah ekspresi boolean dengan fungsi (and/or/not)*/

boolean is_bool_opr(str exp,sheet sh);
/*Menghasilkan true apabila ekspresi exp adalah ekspresi boolean dengan operator*/

boolean solve_bool(str exp,sheet sh);
/*Asumsi: exp merupakan ekspresi boolean.
 fungsi ini menyelesaikan fungsi boolean dengan operator, ekspresi boolean fungsi/cell/explicit*/

boolean solve_bool_func(str function, sheet sh);
/*  Menghasilkan hasil fungsi boolean (and, or, not) atau 
	menampilkan isi suatu sel bertipe boolean atau
	menghasilkan true apabila function="TRUE"*/

str solve_char(str exp,sheet sh);
/*fungsi solve_char menyelesaikan ekspresi karakter (KONKAT)*/

boolean is_operator(char bch, char ch);
/*bch=before ch
  Menghsilkan true apabila ch adalah operator, apabila ch='-' hasil tergantung bch*/

boolean is_float(char bch, char ch);
/*bch=before ch
  Menghsilkan true apabila ch adalah float (bilangan real), apabila ch='-' hasil tergantung bch*/

str purify(str raw_exp,sheet sh);
/*menyelesaikan semua fungsi yang ada di dalam ekspresi matematika raw_exp, dan memisahkan 
 tiap elemen operasi dengan spasi*/


float solve_arithmetic_func(str function, sheet sh);
/*menyelesaikan fungsi aritmatika (sqr,sqrt,mod,div,sum,max,min)*/

boolean is_higher_prec(char a, char b);
/*Menghasilkan true apabila operator b lebih "tinggi" daripada a*/

void insert_operator(char o,str *opr,str *postfix);
/*I.S : o adalah operator
  F.S : Apabila o lebih "tinggi" daripada operator di paling atas di stack, o dimasukkan ke stack
        Apabila o lebih "rendah"/"seimbang" daripada operator di paling atas di stack, operator di stack dimasukkan ke postfix*/

str infix_to_postfix(str exp);
/*fungsi infix_to_postfix mengubah ekspresi infix exp menjadi postfix*/

float solve_postfix(str postfix);
/*fungsi solve_postfix menyelesaikan ekspresi aritmatika yang sidah berbentuk postfix*/

float solve_arithmetic(str s,sheet sh);
/*fungsi solve_arithmetic menyelesaikan ekspresi aritmatika*/

str solve_if(str s,sheet sh);
/*fungsi solve_if menyelesaikan ekspresi if*/

str solve_formula(str exp,sheet sh);
/*Menyelesaikan segala ekspresi (baik aritmatika, karakter, if, maupun boolean*/

#endif

