//file : adtsheet.h
#include "..\boolean.h"
#include <stdio.h>
#include "..\ADT-string\str.h"
#ifndef sheet_H
#define sheet_H

/***DEFINISI TYPE SHEET***/
typedef int index;//type index baris dan kolom

/*Ukuran minimum dan maksimum baris dan kolom*/
#define barismin 1
#define barismax 26
#define kolommin 1
#define kolommax 100 

typedef str cell_type;
typedef int address[3];
typedef struct
	{
	cell_type cell[kolommax-kolommin+2][barismax-barismin+2];//tabel
	address index_list[barismax*kolommax+1];//untuk menyimpan alamt cell yang terisi
	int elements;//banyaknya cell yang terisi
	}sheet;

//kamus global
extern sheet newsheet;
extern sheet openedsheet;	

/****DEFINISI PROTOTYPE PRIMITIF****/	
/**Konstruktor membentuk sheet**/
sheet new_sheet();
/*Membentuk sheet kosong
I.S. sheet belum terdefinisi
F.S. sheet terdefinisi*/

/***Selektor cell***/
#define infocell(sh,i,j) (sh).cell[i][j]
#define panjang_infocell(sh,i,j) ((sh).cell[i][j]).length
#define indexlistkolom(sh,i) ((sh).index_list[i][1])
#define indexlistbaris(sh,i) ((sh).index_list[i][2])
#define elementinsheet(sh) (sh).elements

/*Fungsi dan Prosedur untuk sheet yang terdefinisi*/
boolean isspec(str spec);
//mengembalikan true jika spec adalah nilai atau formula
boolean isnilai(str spec);
//mengembalikan true jika spec=nilai
boolean isarea(str alamat);
/*mengembalikan true jika ada ':' pada alamat*/
boolean isnilai(str x);
/*mengembalikan true jika x adalah nilai*/
void read_cell(str alamat,index *kol,index *brs);
/*merubah array of char menjadi alamat sel
I.S. alamt sel belum terdefinisi
F.S. alamt sel terdefinisi dengan type index*/
void read_area(str alamat,index *kolmin,index *brsmin,index *kolmax,index *brsmax);
/*merubah array of char menjadi alamat area sel
I.S. alamt sel belum terdefinisi
F.S. alamt area sel terdefinisi dengan type index*/
void write_to_sel(sheet *sh,cell_type val,index kol,index brs);
/*Menulis val ke sel dengan alamt baris:kol alamt kolom:brs*/
void write_to_sel_sheet(sheet *sh,str alamat,str isi);
/*Menulis val ke sel
I.S. sheet sudah terdefinisi
F.S. val sudah terdapat di dalam sheet*/
void tulis_isi_sel(sheet sh,index kol,index brs);
/*menampilkan ke layar isi sel
I.S. sheet terdefinisi,sel dengan alamt kol dan brs terdefinisi
F.S. menampilkan ke layar isi sel*/
void remove_isi_sel(sheet *sh,index kol,index brs);
/*
I.S. sheet terdefinisi,sel dengan alamat kol dan brs terdefinsisi
F.S. sel dengan alamat kol dan brs telah kosong*/
void remove_isi_sel_sheet(sheet *sh,str alamat);
/*
I.S. sheet terdefinisi,sel dengan alamat kol dan brs terdefinsisi
F.S. sel dengan alamat kol dan brs telah kosong*/
void remove_isi_sel_area(sheet *sh,index kolmin,index brsmin,index kolmax,index brsmax);
/*
I.S. sheet terdefinisi,sel dengan alamat kol dan brs terdefinsisi
F.S. area sheet dengan alamat kolmin dan brsmin dan kol max brsmax telah kosong*/
void remove_isi_sel_area_sheet(sheet *sh,str area);
/*
I.S. sheet terdefinisi,sel dengan alamat kol dan brs terdefinsisi
F.S. area sheet dengan alamat kolmin dan brsmin dan kol max brsmax telah kosong*/
void display(sheet sh,index kolmin,index brsmin,index kolmax,index brsmax,boolean nilai);
/*
I.S sheet terdefinisi
F.S menampilkan ke layar area sel
*/
int maxlength(int a,int b);
//fungsi antara untuk display mencari panjang kolom terlebar
void display_spesific(sheet sh,str alamat,str spec);
/*
I.S sheet terdefinisi
F.S menampilkan ke layar area sel
proses display
*/

#endif
