#include "..\ADT-mesin_karakter\text_file.h"
#include <stdlib.h>
//ADT str
#ifndef str_h
#define str_h

typedef struct{
				char *d;
				int length;
				int size;
			  } str;

str new_string(int size);
/*fungsi new_string menghasilkan string kosong dari array of character*/

str add_char(str s, char c);
/*fungsi add_char mengisi sebuah string kosong (s) dengan sebuah karakter (c)*/

str del_char(str s, int del);
/*fungsi del_char menghapus sebuah karakter dari string (s)
 Prekondisi : string tidak kosong */

str to_lowercase(str s);
/*fungsi to_lowercase mengubah huruf kapital menjadi huruf kecil.
 fungsi ini berguna untuk mentolerir huruf kapital (incase-sensitive)*/

void print_str(str s);
/*I.S : input string s terdefinisi
  F.S : string s ditampilkan ke layar*/

void write_to_file(str s,char file[50]);
/*I.S : input s terdefinisi, "file.psh" kosong
  F.S : string s ditampilkan ke "file.psh" */

str read_file(char file[50]);
/*fungsi read_file membaca karakter per karakter dari file eksternal, kemudian
 menghasilkan output string (s)*/

int char_to_int(char c);
/*fungsi char_to_int mengkonversi karakter menjadi integer*/

str arr_char_to_str(char ch[50]);
/*fungsi arr_char_to_str mengubah array of character menjadi string*/

float str_to_float(str s);
/*fungsi str_to_float mengkonversi string menjadi float (bilangan real)*/

str int_to_str(int i);
/*fungsi int_to_str mengkonversi integer menjadi string*/

str float_to_str(float f);
/*fungsi float_to_str mengkonversi float menjadi string*/

boolean is_same(str s1, str s2);
/*fungsi is_same menghasilkan TRUE jika string s1 sama dengan s2*/

#endif

