#include "..\ADT-string\str.h" //ADT str (termasuk: text_file.h)
#include <time.h>
#include <stdlib.h>
#ifndef toc_h
#define toc_h

typedef struct {
	str name;
	str date;
	str time;
	int size;
} file_details;

typedef struct {
	file_details d[100];
	int num_files;
	str directory;
} toc;

toc opentoc();
/*fungsi opentoc membaca file toc.psc yang berisi nama direktori,
nama file, tanggal, jam, dan ukuran file. Kemudian setelah dibaca, fungsi 
opentoc menghasilkan output bertipe toc*/

str get_date();
/*fungsi get_date memanggil tanggal dari sistem, kemudian menghasilkan output
bertipe str (string)*/

str get_time();
/*fungsi get_time memanggil jam(waktu) dari sistem, kemudian menghasilkan output
bertipe str (string)*/

int get_size(char file_name[50]);
/*fungsi get_size menghitung ukuran file spreadsheet berdasarkan jumlah karakter
yang ada dalam file tersebut. Output get_size bertipe integer, masih dalam satuan BYTE*/

float size_in_kb(char file_name[50]);
/*fungsi size_in_kb mengkonversikan ukuran file ke satuan KILOBYTE (KB)*/

void new_file_toc(toc *tocr, char file_name[50]);
/*I.S : file toc.psc 'kosong' atau berisi daftar nama file
  F.S : jumlah info file dalam daftar file di toc.psc bertambah satu*/

void savetoc(toc tocr, char file_name[50]);
/*I.S : atribut semua file yang ada di toc.psc belum diubah
  F.S : atribut jam, tanggal, dan ukuran sebuah file (yang sudah di-save), telah diubah*/

void delete_all_file(toc *tocr);
/*I.S : isi file toc.psc tidak kosong
  F.S : daftar nama file menjadi kosong (semua file dihapus)*/

void delete_file(int file_place,toc *tocr);
/*I.S : isi file toc.psc tidak kosong
  F.S : salah satu nama file di daftar file dihapus, jumlah file berkurang satu*/

void list_toc(toc tocr);
/*I.S : file toc.psc ada dan terdefinisi, isi toc.psc mungkin 'kosong'
  F.S : daftar nama dan atribut file ditampilkan ke layar command prompt*/

int search_toc(char to_be_searched[50],toc tocr,char search[50]);
/*user memasukkan input atribut file yang akan dicari. fungsi search_toc menghasilkan indeks dimana 
atribut file ditemukan. Indeks tersebut adalah indeks dari tocr.d yang merupakan array of file_details*/

toc adv_search_toc(char to_be_searched[50],toc tocr,char search[50]);
/*user memasukkan input atribut file yang akan dicari. fungsi adv_search_toc menampilkan seluruh 
atribut dari file yang dicari, output fungsi bukan bertipe integer), melainkan toc*/

str min_string(str s1, str s2);
/*fungsi min_string merupakan salah satu fungsi bantuan untuk fungsi sort_toc. input fungsi berupa
dua buah string, kemudian menghasilkan string yang 'lebih kecil' atau yang urutannya paling atas
(berdasarkan alphabet)*/

int get_year(str date);
/*fungsi get_year memanggil tahun dari file toc.psc, disimpan ke dalam struktur internal*/

int get_month(str date);
/*fungsi get_month memanggil bulan dari file toc.psc, disimpan ke dalam struktur internal*/

int get_day(str date);
/*fungsi get_day memanggil hari dari file toc.psc, disimpan ke dalam struktur internal*/

str min_date(str d1, str d2);
/*fungsi min_date membandingkan dua input date (tanggal) yang berupa string, kemudian
menghasilkan tanggal yang lebih awal. misal: 31-12-2008 lebih awal dari 1-1-2009*/

toc sort_toc(toc tocr,char sort[50]);
/*fungsi sort_toc mengurutkan daftar nama file di toc.psc. output fungsi berupa
struktur internal, yaitu toc*/

#endif
